// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockProjects is an autogenerated mock type for the Projects type
type MockProjects struct {
	mock.Mock
}

// CreateProject provides a mock function with given fields: ctx, proj
func (_m *MockProjects) CreateProject(ctx context.Context, proj *models.Project) (*models.Project, error) {
	ret := _m.Called(ctx, proj)

	if len(ret) == 0 {
		panic("no return value specified for CreateProject")
	}

	var r0 *models.Project
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Project) (*models.Project, error)); ok {
		return rf(ctx, proj)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Project) *models.Project); ok {
		r0 = rf(ctx, proj)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Project)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Project) error); ok {
		r1 = rf(ctx, proj)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteProject provides a mock function with given fields: ctx, proj
func (_m *MockProjects) DeleteProject(ctx context.Context, proj *models.Project) error {
	ret := _m.Called(ctx, proj)

	if len(ret) == 0 {
		panic("no return value specified for DeleteProject")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Project) error); ok {
		r0 = rf(ctx, proj)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetProjectByID provides a mock function with given fields: ctx, id
func (_m *MockProjects) GetProjectByID(ctx context.Context, id string) (*models.Project, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetProjectByID")
	}

	var r0 *models.Project
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Project, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Project); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Project)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProjectByPRN provides a mock function with given fields: ctx, prn
func (_m *MockProjects) GetProjectByPRN(ctx context.Context, prn string) (*models.Project, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetProjectByPRN")
	}

	var r0 *models.Project
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Project, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Project); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Project)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProjects provides a mock function with given fields: ctx, input
func (_m *MockProjects) GetProjects(ctx context.Context, input *GetProjectsInput) (*ProjectsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetProjects")
	}

	var r0 *ProjectsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetProjectsInput) (*ProjectsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetProjectsInput) *ProjectsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ProjectsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetProjectsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateProject provides a mock function with given fields: ctx, proj
func (_m *MockProjects) UpdateProject(ctx context.Context, proj *models.Project) (*models.Project, error) {
	ret := _m.Called(ctx, proj)

	if len(ret) == 0 {
		panic("no return value specified for UpdateProject")
	}

	var r0 *models.Project
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Project) (*models.Project, error)); ok {
		return rf(ctx, proj)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Project) *models.Project); ok {
		r0 = rf(ctx, proj)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Project)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Project) error); ok {
		r1 = rf(ctx, proj)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockProjects creates a new instance of MockProjects. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockProjects(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockProjects {
	mock := &MockProjects{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
